/*!
 * AVL Binary search trees
 * https://jjwesterkamp.github.io/avl-bst
 * (c) 2021 Jeffrey Westerkamp
 * This software may be freely distributed under the MIT license.
 */
!function(t,r){"object"==typeof exports&&"object"==typeof module?module.exports=r():"function"==typeof define&&define.amd?define([],r):"object"==typeof exports?exports.AVLTree=r():t.AVLTree=r()}(self,function(){return(()=>{"use strict";var e={d:(t,r)=>{for(var n in r)e.o(r,n)&&!e.o(t,n)&&Object.defineProperty(t,n,{enumerable:!0,get:r[n]})},o:(t,r)=>Object.prototype.hasOwnProperty.call(t,r)},t={};e.d(t,{default:()=>n});var u=function(t,r){this.key=t,this.value=r,this.height=1,this.size=1,this.left=null,this.right=null};function r(t){return null!==(t=null==t?void 0:t.height)&&void 0!==t?t:0}function l(t){t.height=1+Math.max(r(t.left),r(t.right))}function f(t){var r;t.size=1+(null!==(r=null===(r=t.left)||void 0===r?void 0:r.size)&&void 0!==r?r:0)+(null!==(t=null===(t=t.right)||void 0===t?void 0:t.size)&&void 0!==t?t:0)}function o(t){return t?r(t.right)-r(t.left):0}function h(t,r){return t<r?-1:r<t?1:0}function c(t){var r;return null===t?null:null!==(r=c(t.left))&&void 0!==r?r:t}function i(t,r,n){return null===t?n:(n=r(n=i(t.left,r,n),t),i(t.right,r,n))}function a(t){var r=o(t),n=o(t.left),e=o(t.right);return r<-1&&n<=0?v(t):r<-1&&0<n?(t.left=s(t.left),v(t)):1<r&&e<0?(t.right=v(t.right),s(t)):1<r&&0<=e?s(t):t}function s(t){if(null===t.right)throw new Error("Cannot left-rotate a node without a right child");var r=t.right,n=t.right.left;return(r.left=t).right=n,f(t),f(r),l(t),l(r),r}function v(t){if(null===t.left)throw new Error("Cannot right-rotate a node without a left child");var r=t.left,n=t.left.right;return(r.right=t).left=n,f(t),f(r),l(t),l(r),r}var AVLTree=function(){function AVLTree(t){this.getKey=t,this.root=null}return AVLTree.prototype.isEmpty=function(){return null===this.root},AVLTree.prototype.size=function(){var t;return null!==(t=null===(t=this.root)||void 0===t?void 0:t.size)&&void 0!==t?t:0},AVLTree.prototype.minValue=function(){var t;return null!==(t=null===(t=c(this.root))||void 0===t?void 0:t.value)&&void 0!==t?t:null},AVLTree.prototype.maxValue=function(){var t;return null!==(t=null===(t=function t(r){var n;return null===r?null:null!==(n=t(r.right))&&void 0!==n?n:r}(this.root))||void 0===t?void 0:t.value)&&void 0!==t?t:null},AVLTree.prototype.search=function(t){return null!==(t=null===(t=function t(r,n){if(null===r)return null;switch(h(n,r.key)){case-1:return t(r.left,n);case 0:return r;case 1:return t(r.right,n)}}(this.root,t))||void 0===t?void 0:t.value)&&void 0!==t?t:null},AVLTree.prototype.forEach=function(r){!function t(r,n){null!==r&&(t(r.left,n),n(r),t(r.right,n))}(this.root,function(t){return r(t.value)})},AVLTree.prototype.foldLeft=function(n,t){return i(this.root,function(t,r){return n(t,r.value)},t)},AVLTree.prototype.foldRight=function(n,t){return function t(r,n,e){return null===r?e:(e=n(e=t(r.right,n,e),r),t(r.left,n,e))}(this.root,function(t,r){return n(t,r.value)},t)},AVLTree.prototype.keys=function(){return this.toArray(function(t){return t.key})},AVLTree.prototype.values=function(){return this.toArray(function(t){return t.value})},AVLTree.prototype.insert=function(t){var r=function t(r,n,e){var o,i;if(null===e)return[new u(r,n),!0];switch(h(r,e.key)){case 0:return[e,!1];case-1:o=t(r,n,e.left),e.left=o[0],i=o[1];break;case 1:o=t(r,n,e.right),e.right=o[0],i=o[1]}return i?(f(e),l(e),[a(e),!0]):[e,!1]}(this.getKey(t),t,this.root),t=r[0],r=r[1];return this.root=t,r},AVLTree.prototype.delete=function(t){var r=function t(r,n){var e,o;if(null===n)return[null,!1];switch(h(r,n.key)){case-1:i=t(r,n.left),n.left=i[0],e=i[1];break;case 1:u=t(r,n.right),n.right=u[0],e=u[1];break;case 0:var i=null!==n.left,u=null!==n.right;if(!i&&!u)return[null,!0];if(i?!u:u)return[null!==(o=n.left)&&void 0!==o?o:n.right,!0];var i=c(n.right);o=(u={from:i,to:n}).from,(u=u.to).key=o.key,u.value=o.value,i=t(i.key,n.right),n.right=i[0],e=i[1]}return f(n),l(n),[a(n),e]}(t,this.root),t=r[0],r=r[1];return this.root=t,r},AVLTree.prototype.toArray=function(n){return i(this.root,function(t,r){return t.push(n(r)),t},[])},AVLTree}();const n={create:function(t){return new AVLTree(t)},scalar:function(){return new AVLTree(function(t){return t})}};return t.default})()});